Subject: Re: [PATCH net-next v8 16/16] selftests/net: Add netkit container tests

From: Jakub Kicinski <[email-masked]>
Date: Sat, 31 Jan 2026 16:24:27 -0800

On Thu, 29 Jan 2026 23:28:30 +0100 Daniel Borkmann wrote:
> Add two tests using NetDrvContEnv. One basic test that sets up a netkit
> pair, with one end in a netns. Use LOCAL_PREFIX_V6 and nk_forward BPF
> program to ping from a remote host to the netkit in netns.
> 
> Second is a selftest for netkit queue leasing, using io_uring zero copy
> test binary inside of a netns with netkit. This checks that memory
> providers can be bound against virtual queues in a netkit within a
> netns that are leasing from a physical netdev in the default netns.

We should cover the uAPI and the tricky part of the handling please.

So off the top of my head main bits:
 - the expected attributes on lessor and lessee via Netlink
 - destroying the netkit with MP attached
   - checking the state via YNL,
   - attaching MP from the main dev to make sure we didn't leave
     anything behind
 - destroying phys dev while netkit exists (prolly netdevsim :S)
 - making sure XDP can't be attached on phys dev when MP is installed
   via netkit

... whatever else you found to be tricky in the implementation.